dashboard_tonomapa/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.views.decorators.csrf import csrf_exempt
from graphene_django.views import GraphQLView
from rest_framework import routers
from notifications import urls as notifications_urls  # type: ignore
from graphene_file_upload.django import FileUploadGraphQLView

router = routers.DefaultRouter()

from rest_framework_jwt.views import (
    obtain_jwt_token,
    refresh_jwt_token,
    verify_jwt_token,
)
from rest_framework_simplejwt.views import (
    TokenObtainPairView,
    TokenRefreshView,
    TokenVerifyView,
)


urlpatterns = [
    path("relatorios/", include("relatorios.urls")),
    path("", include("main.urls")),
    path("", include("drf_react_by_schema.urls")),
    path("organizacao/<int:organizacao_id>/relatorios/", include("relatorios.urls")),
    path("organizacao/<int:organizacao_id>/", include("main.urls")),
    path("", include("main.organizacao_urls")),
    path("rest/", include(router.urls)),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
    path("admin/", admin.site.urls),
    path("graphql", csrf_exempt(FileUploadGraphQLView.as_view(graphiql=True))),
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    url(r"^accounts/", include("allauth.urls")),
    url(r"^gql", csrf_exempt(GraphQLView.as_view(batch=True))),
    url(r"^api-token-auth/", obtain_jwt_token),
    url(r"^api-token-refresh/", refresh_jwt_token),
    url(r"^api-token-verify/", verify_jwt_token),

    path("api-authentication/token/", TokenObtainPairView.as_view(), name="token_obtain_pair"),
    path("api-authentication/token/refresh/", TokenRefreshView.as_view(), name="token_refresh"),
    path("api-authentication/token/verify/", TokenVerifyView.as_view(), name="token_verify"),

    path("logs/", include("log_viewer.urls")),
]

urlpatterns += [
    # Notifications
    path(
        "inbox/notifications/", include(notifications_urls, namespace="notifications")
    ),
]

if settings.DEBUG:
    import debug_toolbar

    urlpatterns += [
        path("__debug__/", include(debug_toolbar.urls)),
    ]

if settings.DEBUG:
    from django.conf.urls.static import static

    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

main/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.urls import path

# from django.views.generic import RedirectView

from . import views
from .autocomplete import (
    TerritorioAutocomplete,
    ReviewerAutocomplete,
    MunicipioAutocomplete,
    TipoComunidadeAutocomplete,
    EstadoAutocomplete,
    BiomaAutocomplete,
    UserNotReviewerAutocomplete,
)

urlpatterns = [
    path("", views.IndexView.as_view(), name="MainIndex"),
    path("anexos/", views.AnexoView.as_view(), name="anexos_view"),
    path(
        "codigo-seguranca/",
        views.PedidoCodigoSegurancaView.as_view(),
        name="pedido_codigo_seguranca_view",
    ),
    path("termosdeuso", views.TermosDeUsoView.as_view(), name="termosdeuso_view"),
    path("ticcas", views.TICCAsView.as_view(), name="ticcas_view"),
]

urlpatterns += (
    path("usuarias/", views.UsuariaListView.as_view(), name="usuaria_list"),
    path("revisoras/", views.RevisoraListView.as_view(), name="revisora_list"),
    path("usuarias/create/", views.UsuariaCreateView.as_view(), name="usuaria_create"),
    path(
        "usuarias/detail/<int:pk>/",
        views.UsuariaDetailView.as_view(),
        name="usuaria_detail",
    ),
    path(
        "usuarias/update/<int:pk>/",
        views.UsuariaUpdateView.as_view(),
        name="usuaria_update",
    ),
)

urlpatterns += (
    path(
        "territorio/detail/<int:pk>/",
        views.TerritorioDetailView.as_view(),
        name="territorio_detail",
    ),
    path(
        "territorio/relatorio/<int:pk>/",
        views.TerritorioDetailReportView.as_view(),
        name="territorio_report",
    ),
    path(
        "territorio/update/<int:pk>/",
        views.TerritorioUpdateView.as_view(),
        name="territorio_update",
    ),
    path(
        "territorio/delete/<int:pk>/",
        views.TerritorioDeleteView.as_view(),
        name="territorio_delete",
    ),
    path(
        "territorio/mensagens/<int:territorio_id>/",
        views.MensagemCreateView.as_view(),
        name="territorio_mensagens",
    ),
    path(
        "territorio/revisora/desassociar/<int:pk>",
        views.RevisoraTerritorioDesassociarView.as_view(),
        name="revisora_desassociar",
    ),
    path(
        "territorio/organizacao/desassociar/<int:pk>",
        views.OrganizacaoTerritorioDesassociarView.as_view(),
        name="organizacao_desassociar",
    ),
)

urlpatterns += (
    # urls for TerritorioUsuaria
    path(
        "usuarias/detail/<int:pk>/territorios/",
        views.UsuariaTerritorioUpdateView.as_view(),
        name="usuaria_territorios",
    ),
)

urlpatterns += (
    # urls for MunicipioUsuaria
    path(
        "usuarias/detail/<int:pk>/municipios/",
        views.UsuariaMunicipioUpdateView.as_view(),
        name="usuaria_municipios",
    ),
    path(
        "municipio/desassociar/<int:pk>/<int:usuaria_id>/",
        views.UsuariaMunicipioDesassociarView.as_view(),
        name="municipio_desassociar",
    ),
)

urlpatterns += [
    # Autocomplete
    path(
        "territorio-autocomplete/",
        TerritorioAutocomplete.as_view(),
        name="territorio-autocomplete",
    ),
    path(
        "reviewer-autocomplete/",
        ReviewerAutocomplete.as_view(),
        name="reviewer-autocomplete",
    ),
    path(
        "user-not-reviewer-autocomplete/",
        UserNotReviewerAutocomplete.as_view(create_field="username"),
        name="user-not-reviewer-autocomplete",
    ),
    path(
        "municipio-autocomplete/",
        MunicipioAutocomplete.as_view(),
        name="municipio-autocomplete",
    ),
    path(
        "comunidade-autocomplete/",
        TipoComunidadeAutocomplete.as_view(),
        name="comunidade-autocomplete",
    ),
    path(
        "estado-autocomplete/",
        EstadoAutocomplete.as_view(),
        name="estado-autocomplete",
    ),
    path(
        "bioma-autocomplete/",
        BiomaAutocomplete.as_view(),
        name="bioma-autocomplete",
    ),
    path(
        "ajax/municipios/<int:organizacao_id>/<int:estado_id>",
        views.AjaxMunicipiosOuEstadosList.as_view(),
        name="ajax_municipios_list",
    ),
    path(
        "ajax/municipios/",
        views.AjaxMunicipiosOuEstadosList.as_view(),
        name="ajax_municipios_list",
        kwargs={"empty": True},
    ),
    path(
        "ajax/estados/<int:organizacao_id>",
        views.AjaxMunicipiosOuEstadosList.as_view(),
        name="ajax_estados_list",
    ),
    path(
        "ajax/estados/",
        views.AjaxMunicipiosOuEstadosList.as_view(),
        name="ajax_estados_list",
        kwargs={"empty": True},
    ),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

main/models.py
import json
import os
import re
import uuid
from datetime import datetime
from random import randint

import magic
from dirtyfields import DirtyFieldsMixin
from django.conf import settings
from django.contrib.auth.models import AbstractUser
from django.contrib.gis.db import models
from django.contrib.staticfiles import finders
from django.contrib.staticfiles.storage import staticfiles_storage

# from typing import Optional
from django.core.exceptions import ValidationError
from django.db import IntegrityError, transaction
from django.db.models import JSONField, Q
from django.urls import reverse, reverse_lazy
from django.utils import timezone
from django.utils.functional import cached_property
from django_archive_mixin.mixins import ArchiveMixin  # type: ignore
from exponent_server_sdk import (
    DeviceNotRegisteredError,
    PushClient,
    PushMessage,
    PushServerError,
    PushTicketError,
)
from collections import defaultdict
from imagekit import ImageSpec  # type: ignore
from notifications.signals import notify
from pilkit.processors import ResizeToFill, Transpose  # type: ignore
from requests.exceptions import ConnectionError, HTTPError

from main.utils import (
    conta_territorios_organizacao,
    get_choice,
    get_mapa_status,
    get_mapa_status_rev,
    get_territorios_visiveis_organizacao,
)


class BaseModel(ArchiveMixin, models.Model):
    class Meta:
        abstract = True


class Device(models.Model):
    usuaria = models.ForeignKey("Usuaria", models.CASCADE, related_name="devices")
    push_token = models.CharField(max_length=120)
    criacao = models.DateTimeField(auto_now_add=True, editable=False)
    ultima_alteracao = models.DateTimeField(auto_now=True, editable=False)
    active = models.BooleanField(default=True)

    class Meta:
        ordering = ("-ultima_alteracao",)


class Usuaria(AbstractUser):
    telefone = models.CharField(max_length=15, blank=True, null=True)
    codigo_uso_celular = models.CharField(max_length=8, blank=True, null=True)
    is_admin = models.BooleanField(blank=True, null=True)
    is_reviewer = models.BooleanField(blank=True, null=True)
    is_parceira = models.BooleanField(blank=True, null=True)
    aprovado = models.BooleanField(blank=False, null=False, default=False)
    cpf = models.CharField(max_length=15, blank=True, null=True)
    email = models.CharField(max_length=100, blank=True, null=True)
    solicitou_codigo = models.BooleanField(blank=True, null=True)
    foto_documento = models.ImageField(
        null=True, blank=True, upload_to="anexos/%Y/%m/%d/"
    )
    ultima_alteracao = models.DateTimeField(auto_now=True, editable=False)
    current_territorio = models.ForeignKey(
        "Territorio", models.SET_NULL, blank=True, null=True
    )

    __original_codigo_uso_celular = None
    organizacoes_que_administra_cached = None
    organizacoes_que_administra_ids_cached = None
    usuarias_de_organizacoes_que_administra_cached = None

    def __init__(self, *args, **kwargs):
        super(Usuaria, self).__init__(*args, **kwargs)
        self.__original_codigo_uso_celular = self.codigo_uso_celular

    territorios = models.ManyToManyField(
        "Territorio",
        through="TerritorioUsuaria",
        related_name="usuarias",
        blank=True,
    )

    municipios = models.ManyToManyField(
        "Municipio",
        through="MunicipioUsuaria",
        related_name="usuarias",
        blank=True,
    )

    @property
    def territorios_revisora_stats(self):
        stats = {}
        for territorio in self.territorios_revisora.all():
            status = territorio.status_revisao.first().status
            if status not in stats:
                stats[status] = {"label": get_choice(status), "count": 0}
            stats[status]["count"] += 1
        return stats

    @property
    def territorios_para_revisar(self):
        return self.territorios_revisora.filter(
            status_revisao__status=TerritorioRevisaoStatus.A_REVISAR
        )

    @property
    def territorios_para_revisar_novos(self):
        return self.territorios_revisora.filter(
            status_revisao__status=TerritorioRevisaoStatus.A_REVISAR, eh_reenvio=False
        )

    @property
    def territorios_para_revisar_reenviados(self):
        return self.territorios_revisora.filter(
            status_revisao__status=TerritorioRevisaoStatus.A_REVISAR, eh_reenvio=True
        )

    @property
    def territorios_que_aprovou(self):
        return self.territorios_revisora.filter(
            status_revisao__status=TerritorioRevisaoStatus.APROVADO
        )

    @property
    def territorios_que_rejeitou(self):
        return self.territorios_revisora.filter(
            status_revisao__status=TerritorioRevisaoStatus.REJEITADO
        )

    @property
    def territorios_em_analise(self):
        return self.territorios_revisora.filter(
            status_revisao__status__in=[
                TerritorioRevisaoStatus.REVISANDO,
                TerritorioRevisaoStatus.COM_DUVIDAS,
                TerritorioRevisaoStatus.REVISADO_COM_PENDENCIAS,
            ]
        )

    @property
    def territorios_processados(self):
        return self.territorios_revisora.filter(
            status_revisao__status__in=[
                TerritorioRevisaoStatus.APROVADO,
                TerritorioRevisaoStatus.REJEITADO,
                TerritorioRevisaoStatus.ENVIADO_PTT,
                TerritorioRevisaoStatus.ENVIADO_PTT_NAFILA,
                TerritorioRevisaoStatus.ENVIADO_PTT_NAFILA_ARQUIVOS,
            ]
        )

    @property
    def mensagens_territorios_em_analise(self):
        territorios = self.territorios_em_analise
        return Mensagem.objects.filter(territorio__in=territorios)

    @property
    def is_cadastrante(self):
        return not self.has_perm("permissao_padrao")

    def eh_cadastrante_do_territorio(self, territorio):
        if not self.is_cadastrante:
            return False
        try:
            self.territorios.get(pk=territorio.id)
            return True
        except:
            return False

    @property
    def organizacoes_que_administra(self):
        if self.organizacoes_que_administra_cached:
            return self.organizacoes_que_administra_cached

        if self.is_reviewer:
            self.organizacoes_que_administra_cached = Organizacao.objects.none()
            return self.organizacoes_que_administra_cached

        self.organizacoes_que_administra_cached = Organizacao.objects.all()

        if not self.has_perm("admin_geral"):
            organizacoes_que_administra_ids = self.org_usuarias.filter(
                is_admin=True
            ).values_list("organizacao_id")
            self.organizacoes_que_administra_cached = (
                self.organizacoes_que_administra_cached.filter(
                    id__in=organizacoes_que_administra_ids
                )
            )

        return self.organizacoes_que_administra_cached

    @property
    def organizacoes_que_administra_ids(self):
        if self.organizacoes_que_administra_ids_cached:
            return self.organizacoes_que_administra_ids_cached

        self.organizacoes_que_administra_ids_cached = (
            self.organizacoes_que_administra.values_list("id")
        )
        return self.organizacoes_que_administra_ids_cached

    @property
    def usuarias_de_organizacoes_que_administra(self):
        if self.usuarias_de_organizacoes_que_administra_cached:
            return self.usuarias_de_organizacoes_que_administra_cached

        usuarias = Usuaria.objects

        if self.is_reviewer:
            return usuarias.none()

        if self.has_perm("admin_geral"):
            self.usuarias_de_organizacoes_que_administra_cached = usuarias.all()
            return self.usuarias_de_organizacoes_que_administra_cached

        # Warning: the field for distinct must be the same os the field of "order_by"! In this case: 'first_name'
        self.usuarias_de_organizacoes_que_administra_cached = usuarias.filter(
            organizacoes__in=self.organizacoes_que_administra
        ).distinct("first_name")
        return self.usuarias_de_organizacoes_que_administra_cached

    @property
    def revisoras_de_organizacoes_que_administra(self):
        return self.usuarias_de_organizacoes_que_administra.filter(is_reviewer=True)

    @property
    def territorios_de_organizacoes_que_administra(self):
        return Territorio.objects.filter(
            organizacao_id__in=self.organizacoes_que_administra_ids
        )

    def get_current_territorio(self, territorio_id=None):
        if not territorio_id and self.current_territorio:
            return self.current_territorio

        if territorio_id:
            if (
                not self.current_territorio
                or self.current_territorio.id != territorio_id
            ):
                try:
                    self.current_territorio = self.territorios.get(pk=territorio_id)
                except Territorio.DoesNotExist:
                    self.current_territorio = None
                self.save()
            return self.current_territorio

        current_territorio = self.territorios.order_by("-ultima_alteracao").first()
        if not current_territorio:
            current_territorio = Territorio.objects.create()

        self.current_territorio = current_territorio
        self.save()
        return current_territorio

    def __str__(self):
        return self.get_full_name() if self.get_full_name() != "" else self.username

    def get_displayname(self):
        return self.first_name if self.first_name != "" else self.username

    def get_absolute_url(self):
        return reverse("usuaria_detail", args=(self.pk,))

    def get_update_url(self):
        return reverse("usuaria_update", args=(self.pk,))

    def set_full_name(self, full_name):
        full_name_splitted = re.sub(" +", " ", full_name).strip().split(" ", 1)
        if len(full_name_splitted) == 1:

main/templates/main/index.html
{% extends "base.html" %}
{% load grafico_tags %}
{% block content %}
    Por favor faça o login.
{% endblock content %}

main/templates/main/mensagem_form.html
{% extends "base.html" %}
{% load static %}
{% load crispy_forms_tags %}
{% load humanize %}
{% load rules %}
{% load mensagem_tags %}
{% block content %}
    {% has_perm 'territorio.visualizar' user territorio as pode_visualizar_territorio %}
    {% has_perm 'admin_geral' user as admin_geral %}
    {% if pode_visualizar_territorio %}
        <h3>
            {{ titulo }}
            <a href="{{ territorio.get_absolute_url }}"
               style="float: right"
               class="btn btn-primary btn-sm"><i class="fa fa-close mr-1"></i> Voltar</a>
        </h3>
        <div class="row">
            <div class="col-md-4">
                <h3>Mensagens</h3>
                {% if mensagens_antigas|length > 0 %}
                    <table class="table table-bordered fit-to-page">
                        <tbody>
                            {% for mensagem in mensagens_antigas %}
                                <tr class="{% if mensagem.remetente_id == user.id %}mensagem_enviada{% else %}mensagem_recebida{% endif %}">
                                    <td>
                                        <div>
                                            <strong class="mensagem_meta">{{ mensagem.remetente }}:</strong>
                                            <br />
                                            {{ mensagem.texto|linebreaksbr }}
                                            <br />
                                            <span class="mensagem_meta">{{ mensagem.data_envio|date:"G:i" }} | {{ mensagem.data_envio|naturalday }}
                                                {% if not mensagem.origin_is_device %}
                                                    {% mensagem_status mensagem %}
                                                {% endif %}
                                            </span>
                                        </div>
                                    </td>
                                </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                {% endif %}
                <div class="mt-5">{% crispy form %}</div>
            </div>
            {% if admin_geral %}
                <div class="col-md-8">
                    <h3>SAC</h3>
                    {% crispy sac_form %}
                </div>
            {% endif %}
        </div>
    {% endif %}
{% endblock content %}

main/templates/main/organizacao_form.html
{% extends "base.html" %}
{% load static %}
{% load crispy_forms_tags %}
{% block content %}
    <h3>{{ titulo }}</h3>
    <div class="row">
        <div class="col-md-12 mt-5">{% crispy form %}</div>
    </div>
{% endblock content %}

main/templates/main/organizacao_list.html
{% extends "base.html" %}
{% load crispy_forms_tags %}
{% load static %}
{% load vstatic %}
{% load rules %}
{% block includes %}
    <link href="{% vstatic 'main/gentelella/select2/dist/css/select2.min.css' %}"
          rel="stylesheet"/>
{% endblock includes %}
{% block includes_footer %}
    <script>
        let ajax_organizacao_id = "";
        let ajax_estado_id = "";
        const ajax_estados_url = "{% url 'ajax_estados_list' %}";
        const ajax_municipios_url = "{% url 'ajax_municipios_list' %}";
    </script>
    <script src="{% vstatic 'main/gentelella/select2/dist/js/select2.full.min.js' %}"></script>
    <script type="text/javascript"
            src="{% vstatic 'main/js/organizacao_list.js' %}"></script>
{% endblock includes_footer %}
{% block content %}
    {% has_perm 'organizacao.cadastrar' user as pode_cadastrar_organizacao %}
    <div class="row">
        <div class="col-md-6">
            <h3>Organizações</h3>
        </div>
        <div class="col-md-6">
            {% if pode_cadastrar_organizacao %}
                <a href="{% url 'organizacao_create' %}"
                   class="btn btn-primary pull-right top-setepx">Nova organização</a>
            {% endif %}
        </div>
    </div>
    <div class="row mt-5">
        {% if organizacoes_list|length > 0 %}
            <div class="col-md-12">
                <table class="table table-bordered table-striped table-condensed"
                       id="organizacoes_list_table">
                    <thead>
                        <tr>
                            <th>Organização</th>
                            <th>Estados/Municípios acessíveis</th>
                            <th>Revisoras/es</th>
                            <th>Administradoras/es</th>
                            <th>Comunidades visíveis</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for organizacao in organizacoes_list %}
                            <tr data-organizacao="{{ organizacao.nome }}"
                                data-organizacao_id="{{ organizacao.id }}">
                                <td>
                                    <a href="{{ organizacao.url }}">{{ organizacao.nome }}</a>
                                </td>
                                <td>
                                    <div class="inner_cell_with_button">
                                        <div class="inner_cell_content">
                                            {% for municipio in organizacao.municipios %}
                                                <span class="badge badge-municipio">
                                                    {{ municipio }}
                                                    <a href="{% url 'organizacao_remover_municipio' organizacao_id=organizacao.id municipio_id=municipio.id %}"
                                                       data-municipio_id="{{ municipio.id }}"
                                                       data-municipio="{{ municipio }}"
                                                       class="organizacao_remover_municipio">
                                                        <i class="fa fa-times"></i>
                                                    </a>
                                                </span>
                                            {% endfor %}
                                            {% for estado in organizacao.estados %}
                                                <span class="badge badge-estado">
                                                    {{ estado.uf }}
                                                    <a href="{% url 'organizacao_remover_estado' organizacao_id=organizacao.id estado_id=estado.id %}"
                                                       data-estado_id="{{ estado.id }}"
                                                       data-estado="{{ estado.uf }}"
                                                       class="organizacao_remover_estado">
                                                        <i class="fa fa-times"></i>
                                                    </a>
                                                </span>
                                            {% endfor %}
                                        </div>
                                        <div class="inner_cell_button">
                                            <button class="adicionar_municipio_ou_estado btn btn-sm btn-default">
                                                <i class="fa fa-plus"></i>
                                            </button>
                                        </div>
                                    </div>
                                </td>
                                <td>{{ organizacao.num_revisoras }}</td>
                                <td>{{ organizacao.num_administradoras }}</td>
                                <td class="cell_num_territorios">{{ organizacao.num_territorios }}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        {% else %}
            <div class="col-md-12">
                <div class="alert alert-dark">
                    <h5>
                        Ainda não há organizações cadastradas. Seja a/o primeira/o a
                        <a href="{% url 'organizacao_create' %}">criar uma</a>.
                    </h5>
                </div>
            </div>
        {% endif %}
    </div>
    <div id="municipio-visibilizar-modal"
         class="modal fade"
         role="dialog"
         style="display: none"
         aria-hidden="true">
        <div class="modal-dialog modal-sm">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">
                        Escolha o estado e/ou o município que deseja tornar acessível para a organização <b><span></span></b>
                    </h4>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Fechar">
                        <span aria-hidden="true"><i class="fa fa-times"></i></span>
                    </button>
                </div>
                <div class="modal-body">{% crispy form %}</div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Fechar</button>
                    <button type="button" class="btn btn-primary" id="municipio-associar-submit">Salvar</button>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

main/templates/main/usuaria_form.html
{% extends "base.html" %}
{% load static %}
{% load crispy_forms_tags %}
{% load rules %}
{% load organizacao_tags %}
{% load vstatic %}
{% has_perm 'admin_geral' user as admin_geral %}
{% block content %}
    {% if object.is_reviewer %}
        <div class="row">
            <div class="col-md-12 alert alert-info">
                <h3>Situação das comunidades revisadas:</h3>
                {% if object.territorios_revisora_stats.items %}
                    {% for id, stat in object.territorios_revisora_stats.items %}
                        <dt>
                            {{ stat.label }}:
                        </dt>
                        <dd>
                            {{ stat.count }}
                        </dd>
                    {% endfor %}
                {% else %}
                    Esta/e usuária/o não está revisando nenhuma
                    comunidade.
                {% endif %}
            </div>
        </div>
    {% endif %}
    {% if object.solicitou_codigo and admin_geral %}
        <div class="row mt-4">
            <div class="col-md-12">
                <h4 class="alert alert-warning">
                    <i class="fa fa-exclamation-circle mr-2"></i> Esta(e) usuária(o) solicita o seu código de segurança. O pedido ocorreu em {{ object.ultima_alteracao }}.
                </h4>
                {% if object.foto_documento %}
                    <h3>Foto do documento</h3>
                    <div class="col-md-55 anexo_container">
                        <div class="thumbnail">
                            <div class="image view view-first">
                                <a href="{{ object.foto_documento.url }}" target="_blank">
                                    <img alt="foto do documento" src="{{ object.foto_documento.url }}" />
                                </a>
                            </div>
                        </div>
                    </div>
                {% endif %}
            </div>
        </div>
    {% endif %}
    <div class="row">
        <div class="col-md-12 mt-5">
            <h3 class="mb-5">
                {{ titulo }}
                <a href="{% prefix_url_organizacao %}{% url 'usuaria_list' %}"
                   style="float: right"
                   class="btn btn-primary btn-sm">
                    <i class="fa fa-arrow-left mr-1"></i> Voltar
                </a>
                {% if object.id and admin_geral %}
                    <a href="{% url 'usuaria_municipios' object.id %}"
                       style="float: right"
                       class="btn btn-warning btn-sm">Associar a municípios para revisão automática</a>
                    <a href="{% url 'TerritorioAgregadoIndex' %}?usuaria={{ object.id }}"
                       style="float: right"
                       class="btn btn-warning btn-sm">
                        {% if organizacao_id %}
                            Gerenciar comunidades a revisar
                        {% else %}
                            Gerenciar participação em organizações e comunidades a revisar
                        {% endif %}
                    </a>
                {% endif %}
            </h3>
            {% crispy form %}
        </div>
    </div>
{% endblock content %}
{% block includes_footer %}
    <script>
        {% if not organizacao_id %}
            function perfil_clean_values() {
                $('#id_is_superuser').val('');
                $('#id_is_admin').val('');
                $('#id_is_reviewer').val('');
                $('#id_is_parceira').val('');
            }

            function perfil_set_initial() {
                if ($('#id_is_reviewer').val() == 'True') {
                    $('#id_perfil_2').prop("checked", true);
                } else if ($('#id_is_admin').val() == 'True') {
                    $('#id_perfil_4').prop("checked", true);
                } else if ($('#id_is_parceira').val() == 'True') {
                    $('#id_perfil_3').prop("checked", true);
                } else {
                    $('#id_perfil_1').prop("checked", true);
                }
            }

            perfil_set_initial();

            $('#div_id_perfil input').click(function(){
                perfil_clean_values();
                var option = $(this).val();
                if (! option) {
                    return;
                }
                $('#id_' + option).val('true');
            });
        {% endif %}
        $('#div_id_password').hide();
    </script>
    {% if object.is_superuser %}
        <script>
            $("#div_id_perfil div").html('<div class="alert alert-info">Esta(e) usuária(o) é administrador(a) geral do sistema (superadmin).<br />Só é possível transformar um(a) usuária(o) em superadmin ou retirar esta atribuição através da interface administrativa.');
        </script>
    {% elif object.is_admin %}
        <script>
            $("#div_id_perfil div").html('<div class="alert alert-info">Esta(e) usuária(o) é administrador(a).<br /> Só administradoras(es) gerais do sistema (superadmins) podem alterar seu perfil.</div>');
        </script>
    {% endif %}
{% endblock includes_footer %}